{*************************************************************************}
{ TESBPCSMathLib component for TMS Software's TAdvSpreadGrid              }
{ for Delphi 4.0,5.0,6.0 & C++ Builder 4 & 5                              }
{ version 1.0.0, 26 Aug 2001                                                }
{                                                                         }
{ written by                                                              }
{    ESB Consultancy                                                      }
{    copyright  2001                                                     }
{    Email:support@esbconsult.com.au                                      }
{    Web:http://www.esbconsult.com.au                                     }
{                                                                         }
{ Based on work by                                                        }
{    TMS Software                                                         }
{    copyright  2001                                                     }
{    Email:info@tmssoftware.com                                           }
{    Web:http://www.tmssoftware.com                                       }
{                                                                         }
{ Requires the ESBPCS v2 or Better available from:                        }
{    http://www.esbconsult.com.au/esbpcs.html                             }
{                                                                         }
{ and naturally also requires TAdvSpreadGrid v1.7 or better from:         }
{    http://www.tmssoftware.com.au                                        }
{                                                                         }
{ Registered TMS Owners can purchase ESBPCS at a 20% discount from the    }
{ TMS Registered User Site.                                               }
{                                                                         }
{ The source code is given as is. The author is not responsible           }
{ for any possible damage done due to the use of this code.               }
{ The component can be freely used in any application. The complete       }
{ source code remains property of the author and may not be distributed,  }
{ published, given or sold in any form as such. No parts of the source    }
{ code can be included in any other component or application without      }
{ written authorization of the author.                                    }
{*************************************************************************}

unit ESBPCSMathLib;

interface

uses
	Messages, Classes, Graphics, Controls, Forms, AdvPars;

type
  TESBPCSMathLib = class(TMathLib)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    function HandlesConstant(Constant:string): Boolean; override;
    function GetConstant(Constant:string): Double; override;
    function HandlesFunction(FuncName:string):Boolean; override;
    function CalcFunction(FuncName:string;Params:TParamList;var ErrType,ErrParam: Integer):Double; override;
    function GetEditHint(FuncName:string;ParamIndex: Integer):string; override;
  published
    { Published declarations }
  end;

implementation

uses
	ESBPCSGlobals, ESBPCSMath, ESBPCSStatistics, ESBPCSVector;

{ TESBPCSMathLib }

function TESBPCSMathLib.GetConstant(Constant: string): Double;
begin
	Result := 0.0;

	if Constant = 'SQRT2' then
		Result := Sqrt2
	else	if Constant = 'SQRT3' then
		Result := Sqrt3
	else	if Constant = 'SQRT5' then
		Result := Sqrt5
	else	if Constant = 'SQRT10' then
		Result := Sqrt10
	else	if Constant = 'SQRTPI' then
		Result := SqrtPi
	else	if Constant = 'CBRT2' then
		Result := Cbrt2
	else	if Constant = 'CBRT3' then
		Result := Cbrt3
	else	if Constant = 'CBRT10' then
		Result := Cbrt10
	else	if Constant = 'CBRT100' then
		Result := Cbrt100
	else	if Constant = 'CBRTPI' then
		Result := CbrtPi
	else	if Constant = 'INVSQRT2' then
		Result := InvSqrt2
	else	if Constant = 'INVSQRT3' then
		Result := InvSqrt3
	else	if Constant = 'INVSQRT5' then
		Result := InvSqrt5
	else	if Constant = 'INVSQRTPI' then
		Result := InvSqrtPI
	else	if Constant = 'INVCBRTPI' then
		Result := InvCbrtPi
	else	if Constant = 'ESBE' then
		Result := ESBe
	else	if Constant = 'ESBE2' then
		Result := ESBe2
	else	if Constant = 'ESBEPI' then
		Result := ESBePi
	else	if Constant = 'ESBEPION2' then
		Result := ESBePiOn2
	else	if Constant = 'ESBEPION4' then
		Result := ESBePiOn4
	else if Constant = 'LN2' then
		Result := Ln2
	else if Constant = 'LN10' then
		Result := Ln10
	else if Constant = 'LNPI' then
		Result := LnPi
	else if Constant = 'LOG10BASE2' then
		Result := Log10Base2
	else if Constant = 'LOG2BASE10' then
		Result := Log2Base10
	else if Constant = 'LOG3BASE10' then
		Result := Log3Base10
	else if Constant = 'LOGPIBASE10' then
		Result := LogPiBase10
	else if Constant = 'LOGEBASE10' then
		Result := LogEBase10
	else if Constant = 'ESBPI' then
		Result := ESBPi
	else if Constant = 'INVPI' then
		Result := InvPi
	else if Constant = 'TWOPI' then
		Result := TwoPi
	else if Constant = 'THREEPI' then
		Result := ThreePi
	else if Constant = 'PI2' then
		Result := Pi2
	else if Constant = 'PITOE' then
		Result := PiToE
	else if Constant = 'PION2' then
		Result := PiOn2
	else if Constant = 'PION3' then
		Result := PiOn3
	else if Constant = 'PION4' then
		Result := PiOn4
	else if Constant = 'THREEPION2' then
		Result := ThreePiOn2
	else if Constant = 'FOURPION3' then
		Result := FourPiOn3
	else if Constant = 'TWOTO63' then
		Result := TwoToPower63
	else if Constant = 'ONERADIAN' then
		Result := OneRadian
	else if Constant = 'ONEDEGREE' then
		Result := OneDegree
	else if Constant = 'ONEMINUTE' then
		Result := OneMinute
	else if Constant = 'ONESECOND' then
		Result := OneSecond
	else if Constant = 'ESBGAMMA' then
		Result := ESBGamma
	else if Constant = 'LNRT2PI' then
		Result := LnRt2Pi
	else if Constant = 'SPEEDOFLIGHT' then
		Result := SpeedOfLight
	else if Constant = 'MACHONE' then
		Result := MachOne
	else if Constant = 'ELEMCHARGE' then
		Result := ElemCharge
	else if Constant = 'AVOGADRO' then
		Result := Avogadro
	else if Constant = 'PROTONMASSUNIT' then
		Result := ProtonMassUnit
	else if Constant = 'ELECTRONMASSUNIT' then
		Result := ElectronMassUnit
	else if Constant = 'NEUTRONMASSUNIT' then
		Result := NeutronMassUnit
	else if Constant = 'ATOMICMASSUNIT' then
		Result := AtomicMassUnit
	else if Constant = 'FARADAY' then
		Result := Faraday
	else if Constant = 'PLANCK' then
		Result := Planck
	else if Constant = 'BOLTZMANN' then
		Result := Boltzmann
	else if Constant = 'JOSEPHSON' then
		Result := Josephson
	else if Constant = 'RYDBERG' then
		Result := Rydberg
	else if Constant = 'GRAVCONST' then
		Result := GravConst
	else if Constant = 'GRAVITY' then
		Result := Gravity
	else if Constant = 'AU' then
		Result := AstroUnit
	else if Constant = 'LIGHTYEAR' then
		Result := LightYear
	else if Constant = 'PARSEC' then
		Result := Parsec
	else if Constant = 'ABSZEROC' then
		Result := AbsoluteZeroC
	else if Constant = 'ABSZEROF' then
		Result := AbsoluteZeroF
	else if Constant = 'ATMOSPHERE' then
		Result := Atmosphere
end;

function TESBPCSMathLib.HandlesConstant(Constant: string): Boolean;
begin
	Result := (Constant = 'SQRT2') or
		(Constant = 'SQRT3') or
		(Constant = 'SQRT5') or
		(Constant = 'SQRT10') or
		(Constant = 'SQRTPI') or
		(Constant = 'CBRT2') or
		(Constant = 'CBRT3') or
		(Constant = 'CBRT10') or
		(Constant = 'CBRT100') or
		(Constant = 'CBRTPI') or
		(Constant = 'INVSQRT2') or
		(Constant = 'INVSQRT3') or
		(Constant = 'INVSQRT5') or
		(Constant = 'INVSQRTPI') or
		(Constant = 'INVCBRTPI') or
		(Constant = 'ESBE') or
		(Constant = 'ESBE2') or
		(Constant = 'ESBEPI') or
		(Constant = 'ESBEPION2') or
		(Constant = 'ESBEPION4') or
		(Constant = 'LN2') or
		(Constant = 'LN10') or
		(Constant = 'LNPI') or
		(Constant = 'LOG10BASE2') or
		(Constant = 'LOG2BASE10') or
		(Constant = 'LOG3BASE10') or
		(Constant = 'LOGPIBASE10') or
		(Constant = 'LOGEBASE10') or
		(Constant = 'ESBPI') or
		(Constant = 'INVPI') or
		(Constant = 'TWOPI') or
		(Constant = 'THREEPI') or
		(Constant = 'PI2') or
		(Constant = 'PITOE') or
		(Constant = 'PION2') or
		(Constant = 'PION3') or
		(Constant = 'PION4') or
		(Constant = 'THREEPION2') or
		(Constant = 'FOURPION3') or
		(Constant = 'TWOTO63') or
		(Constant = 'ONERADIAN') or
		(Constant = 'ONEDEGREE') or
		(Constant = 'ONEMINUTE') or
		(Constant = 'ONESECOND') or
		(Constant = 'ESBGAMMA') or
		(Constant = 'LNRT2PI') or
		(Constant = 'SPEEDOFLIGHT') or
		(Constant = 'MACHONE') or
		(Constant = 'ELEMCHARGE') or
		(Constant = 'AVOGADRO') or
		(Constant = 'PROTONMASSUNIT') or
		(Constant = 'ELECTRONMASSUNIT') or
		(Constant = 'NEUTRONMASSUNIT') or
		(Constant = 'ATOMICMASSUNIT') or
		(Constant = 'FARADAY') or
		(Constant = 'PLANCK') or
		(Constant = 'BOLTZMANN') or
		(Constant = 'JOSEPHSON') or
		(Constant = 'RYDBERG') or
		(Constant = 'GRAVCONST') or
		(Constant = 'GRAVITY') or
		(Constant = 'AU') or
		(Constant = 'LIGHTYEAR') or
		(Constant = 'PARSEC') or
		(Constant = 'ABSZEROC') or
		(Constant = 'ABSZEROF') or
		(Constant = 'ATMOSPHERE');
end;

function GCDFunction (Params: TParamList; var ErrType, ErrParam: Integer): LongWord;
var
	X, Y: LongWord;
begin
	Result := 0;
	if Params.Count < 2 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	if (Params.Items [0] >= 0) and (Params.Items [0] <= 1.0 * High (Longword)) then
		X := Round (Params.Items [0])
	else
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 0;
		Exit;
	end;
	if (Params.Items [1] >= 0) and (Params.Items [1] <= 1.0 * High (Longword)) then
		Y := Round (Params.Items [1])
	else
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 1;
		Exit;
	end;
	Result := GCD (X, Y);
end;

function LCMFunction (Params: TParamList; var ErrType, ErrParam: Integer): LongWord;
var
	X, Y: LongInt;
begin
	Result := 0;
	if Params.Count < 2 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	if (Params.Items [0] >= Low (Longint)) and (Params.Items [0] <= 1.0 * High (LongInt)) then
		X := Round (Params.Items [0])
	else
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 0;
		Exit;
	end;
	if (Params.Items [1] >= Low (Longint)) and (Params.Items [1] <= 1.0 * High (LongInt)) then
		Y := Round (Params.Items [1])
	else
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 1;
		Exit;
	end;
	Result := LCM (X, Y);
end;

function RelPrimeFunction (Params: TParamList; var ErrType, ErrParam: Integer): Boolean;
var
	X, Y: LongWord;
begin
	Result := False;
	if Params.Count < 2 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	if (Params.Items [0] >= 0) and (Params.Items [0] <= 1.0 * High (Longword)) then
		X := Round (Params.Items [0])
	else
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 0;
		Exit;
	end;
	if (Params.Items [1] >= 0) and (Params.Items [1] <= 1.0 * High (Longword)) then
		Y := Round (Params.Items [1])
	else
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 1;
		Exit;
	end;
	Result := RelativePrime (X, Y);
end;

function DistanceFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 4 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	Result := ESBDistance (Params.Items [0], Params.Items [1], Params.Items [2],
		Params.Items [3]);
end;

function ESBModFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 2 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	if FloatIsZero (Params.Items [2]) then
	begin
		ErrType := Error_DivisionByZero;
		ErrParam := 1;
		Exit;
	end;

	Result := ESBMod (Params.Items [0], Params.Items [1]);
end;

function ESBRemFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 2 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	if FloatIsZero (Params.Items [2]) then
	begin
		ErrType := Error_DivisionByZero;
		ErrParam := 1;
		Exit;
	end;

	Result := ESBRem (Params.Items [0], Params.Items [1]);
end;

function ESBFactFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
var
	X: LongWord;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	if (Params.Items [0] >= 0) and (Params.Items [0] <= 1.0 * High (Longword)) then
		X := Round (Params.Items [0])
	else
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 0;
		Exit;
	end;
	Result := Factorial (X);
end;

function ESBPermFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
var
	X, Y: LongWord;
begin
	Result := 0;
	if Params.Count < 2 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	if (Params.Items [0] >= 0) and (Params.Items [0] <= 1.0 * High (Longword)) then
		X := Round (Params.Items [0])
	else
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 0;
		Exit;
	end;
	if (Params.Items [1] >= 0) and (Params.Items [1] <= 1.0 * X) then
		Y := Round (Params.Items [1])
	else
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 1;
		Exit;
	end;
	Result := Permutation (X, Y);
end;

function ESBCombFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
var
	X, Y: LongWord;
begin
	Result := 0;
	if Params.Count < 2 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	if (Params.Items [0] >= 0) and (Params.Items [0] <= 1.0 * High (Longword)) then
		X := Round (Params.Items [0])
	else
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 0;
		Exit;
	end;
	if (Params.Items [1] >= 0) and (Params.Items [1] <= 1.0 * X) then
		Y := Round (Params.Items [1])
	else
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 1;
		Exit;
	end;
	Result := BinomialCoeff (X, Y);
end;

function ESBTanFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	if Abs (Params.Items [0]) >= TwoToPower63 then
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 0;
		Exit;
	end;
	Result := ESBTan (Params.Items [0]);
end;

function ESBCotFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	if Abs (Params.Items [0]) >= TwoToPower63 then
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 0;
		Exit;
	end;
	Result := ESBCot (Params.Items [0]);
end;

function ESBArcTanFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 2 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	Result := ESBArcTan (Params.Items [0], Params.Items [1]);
end;

function ESBArcCosFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	Result := ESBArcCos (Params.Items [0]);
end;

function ESBArcSinFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	Result := ESBArcSin (Params.Items [0]);
end;

function ESBSinDegFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	Result := ESBSinDeg (Params.Items [0]);
end;

function ESBCosDegFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	Result := ESBCosDeg (Params.Items [0]);
end;

function ESBTanDegFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	Result := ESBTanDeg (Params.Items [0]);
end;

function ESBCotDegFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	Result := ESBCotDeg (Params.Items [0]);
end;

function ESBArcTanDegFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 2 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	Result := ESBArcTanDeg (Params.Items [0], Params.Items [1]);
end;

function ESBArcCosDegFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	Result := ESBArcCosDeg (Params.Items [0]);
end;

function ESBArcSinDegFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	Result := ESBArcSinDeg (Params.Items [0]);
end;

function ESBGammaFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	Result := Gamma (Params.Items [0]);
end;

function ESBInvGammaFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	Result := InverseGamma (Params.Items [0]);
end;

function ESBLnGammaFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	if FloatIsZero (Params.Items [0]) or (Params.Items [0] < 0) then
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 0;
		Exit;
	end;

	Result := LnGamma (Params.Items [0]);
end;

function ESBBetaFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 2 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	Result := Beta (Params.Items [0], Params.Items [1]);
end;

function ESBInCompBetaFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
begin
	Result := 0;
	if Params.Count < 3 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	if (Params.Items [0] < 0) or (Params.Items [0] > 1) then
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 0;
		Exit;
	end;
	if FloatIsZero (Params.Items [1]) or (Params.Items [1] < 0) then
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 1;
		Exit;
	end;
	if FloatIsZero (Params.Items [2]) or (Params.Items [2] < 0) then
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 2;
		Exit;
	end;
	Result := InCompleteBeta (Params.Items [0], Params.Items [1], Params.Items [2]);
end;

function ESBBinomDistFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
var
	A, N: Integer;
	P: Double;
	Cumulative: Boolean;
begin
	Result := 0;
	if Params.Count < 4 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	if (Params.Items [1] < 1) then
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 1;
		Exit;
	end;
	if (Params.Items [2] < 0) or (Params.Items [2] > 1) then
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 2;
		Exit;
	end;
	A := Round (Params.Items [0]);
	N := Round (Params.Items [1]);
	if A > N then
		A := N;
	P := Params.Items [2];
	Cumulative := not FloatIsZero (Params.Items [3]);
	if Cumulative then
		Result := BinomialLess (P, N, A) + BinomialEq (P, N, A)
	else
		Result := BinomialEq (P, N, A);
end;

function ESBPoissonFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
var
	A: Integer;
	Mean: Double;
	Cumulative: Boolean;
begin
	Result := 0;
	if Params.Count < 3 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	if (Params.Items [1] <= 0) then
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 1;
		Exit;
	end;
	A := Round (Params.Items [0]);
	Mean := Params.Items [1];
	Cumulative := not FloatIsZero (Params.Items [2]);
	if Cumulative then
		Result := PoissonLess (Mean, A) + PoissonEq (Mean, A)
	else
		Result := PoissonEq (Mean, A)
end;

function ESBNormDistFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
var
	A: Double;
	Mean, StdDev: Double;
begin
	Result := 0;
	if Params.Count < 3 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	if (Params.Items [2] <= 0) then
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 2;
		Exit;
	end;
	A := Params.Items [0];
	Mean := Params.Items [1];
	StdDev := Params.Items [2];
	Result := NormalDistLess (Mean, StdDev, A)
end;

function ESBLogNormDistFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
var
	A: Double;
	Mean, StdDev: Double;
begin
	Result := 0;
	if Params.Count < 3 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;
	if (Params.Items [0] <= 0) then
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 0;
		Exit;
	end;
	if (Params.Items [2] <= 0) then
	begin
		ErrType := Error_InvalidValue;
		ErrParam := 2;
		Exit;
	end;
	A := Params.Items [0];
	Mean := Params.Items [1];
	StdDev := Params.Items [2];
	Result := LogNormalLess (Mean, StdDev, A)
end;

function ESBAveFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
var
	I: Integer;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;

	for I := 0 to Params.Count - 1 do
		Result := Result + Params.Items [I];

	Result := Result / Params.Count;
end;

function ESBVarSampFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
var
	I: Integer;
	X: TESBFloatVector;
begin
	Result := 0;
	if Params.Count < 2 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;

	SetLength (X, Params.Count);
	for I := 0 to Params.Count - 1 do
		X [I] := Params.Items [I];

	Result := SampleVariance (X);
end;

function ESBVarPopFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
var
	I: Integer;
	X: TESBFloatVector;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;

	SetLength (X, Params.Count);
	for I := 0 to Params.Count - 1 do
		X [I] := Params.Items [I];

	Result := PopulationVariance (X);
end;

function ESBStdDevSampFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
var
	I: Integer;
	X: TESBFloatVector;
begin
	Result := 0;
	if Params.Count < 2 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;

	SetLength (X, Params.Count);
	for I := 0 to Params.Count - 1 do
		X [I] := Params.Items [I];

	Result := SampleStdDev (X);
end;

function ESBStdDevPopFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
var
	I: Integer;
	X: TESBFloatVector;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;

	SetLength (X, Params.Count);
	for I := 0 to Params.Count - 1 do
		X [I] := Params.Items [I];

	Result := PopulationStdDev (X);
end;

function ESBMedianFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
var
	I: Integer;
	X: TESBFloatVector;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;

	SetLength (X, Params.Count);
	for I := 0 to Params.Count - 1 do
		X [I] := Params.Items [I];

	QSortVector (X);

	Result := GetMedian (X);
end;

function ESBRMSFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
var
	I: Integer;
	X: TESBFloatVector;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;

	SetLength (X, Params.Count);
	for I := 0 to Params.Count - 1 do
		X [I] := Params.Items [I];

	Result := RootMeanSquare (X);
end;

function ESBIQRFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
var
	I: Integer;
	X: TESBFloatVector;
	Q1, Q3: Extended;
begin
	Result := 0;
	if Params.Count < 1 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;

	SetLength (X, Params.Count);
	for I := 0 to Params.Count - 1 do
		X [I] := Params.Items [I];

	QSortVector (X);
	GetQuartiles (X, Q1, Q3);

	Result := Q3 - Q1;
end;

function ESBKurtosisSampFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
var
	I: Integer;
	X: TESBFloatVector;
	Mean, StdDev: Extended;
begin
	Result := 0;
	if Params.Count < 4 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;

	SetLength (X, Params.Count);
	for I := 0 to Params.Count - 1 do
		X [I] := Params.Items [I];

	SampleStdDevAndMean (X, StdDev, Mean);
	Result := GetSampleKurtosis (X, StdDev, Mean);
end;

function ESBKurtosisPopFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
var
	I: Integer;
	X: TESBFloatVector;
	Mean, StdDev: Extended;
begin
	Result := 0;
	if Params.Count < 4 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;

	SetLength (X, Params.Count);
	for I := 0 to Params.Count - 1 do
		X [I] := Params.Items [I];

	PopulationStdDevAndMean (X, StdDev, Mean);
	Result := GetPopulationKurtosis (X, StdDev, Mean);
end;

function ESBSkewSampFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
var
	I: Integer;
	X: TESBFloatVector;
	Mean, StdDev: Extended;
begin
	Result := 0;
	if Params.Count < 3 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;

	SetLength (X, Params.Count);
	for I := 0 to Params.Count - 1 do
		X [I] := Params.Items [I];

	SampleStdDevAndMean (X, StdDev, Mean);
	Result := GetSampleSkew (X, StdDev, Mean);
end;

function ESBSkewPopFunction (Params: TParamList; var ErrType, ErrParam: Integer): Double;
var
	I: Integer;
	X: TESBFloatVector;
	Mean, StdDev: Extended;
begin
	Result := 0;
	if Params.Count < 3 then
	begin
		ErrType := Error_InvalidNrOfParams;
		Exit;
	end;

	SetLength (X, Params.Count);
	for I := 0 to Params.Count - 1 do
		X [I] := Params.Items [I];

	PopulationStdDevAndMean (X, StdDev, Mean);
	Result := GetPopulationSkew (X, StdDev, Mean);
end;

function TESBPCSMathLib.CalcFunction (FuncName: string; Params: TParamList;
	var ErrType,ErrParam: Integer): Double;
begin
	Result := 0.0;
	ErrType := 0;

	if FuncName = 'GCD' then
		Result := GCDFunction (Params, ErrType, ErrParam)
	else if FuncName = 'LCM' then
		Result := LCMFunction (Params, ErrType, ErrParam)
	else if FuncName = 'RELPRIME' then
	begin
		if RelPrimeFunction (Params, ErrType, ErrParam) then
			Result := 1.0
	end
	else if FuncName = 'DISTANCE' then
		Result := DistanceFunction (Params, ErrType, ErrParam)
	else if FuncName = 'EXTMOD' then
		Result := ESBModFunction (Params, ErrType, ErrParam)
	else if FuncName = 'EXTREM' then
		Result := ESBRemFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBFACT' then
		Result := ESBFactFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBPERM' then
		Result := ESBPermFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBCOMB' then
		Result := ESBCombFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBTAN' then
		Result := ESBTanFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBCOT' then
		Result := ESBCotFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBARCTAN' then
		Result := ESBArcTanFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBARCSIN' then
		Result := ESBArcSinFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBARCCOS' then
		Result := ESBArcCosFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBSINDEG' then
		Result := ESBSinDegFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBCOSDEG' then
		Result := ESBCosDegFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBTANDEG' then
		Result := ESBTanDegFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBCOTDEG' then
		Result := ESBCotDegFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBARCTANDEG' then
		Result := ESBArcTanDegFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBARCSINDEG' then
		Result := ESBArcSinDegFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBARCCOSDEG' then
		Result := ESBArcCosDegFunction (Params, ErrType, ErrParam)
	else if FuncName = 'GAMMA' then
		Result := ESBGammaFunction (Params, ErrType, ErrParam)
	else if FuncName = 'INVGAMMA' then
		Result := ESBInvGammaFunction (Params, ErrType, ErrParam)
	else if FuncName = 'LNGAMMA' then
		Result := ESBLNGammaFunction (Params, ErrType, ErrParam)
	else if FuncName = 'BETA' then
		Result := ESBBetaFunction (Params, ErrType, ErrParam)
	else if FuncName = 'INCOMPBETA' then
		Result := ESBInCompBetaFunction (Params, ErrType, ErrParam)
	else if FuncName = 'BINOMDIST' then
		Result := ESBBinomDistFunction (Params, ErrType, ErrParam)
	else if FuncName = 'POISSON' then
		Result := ESBPoissonFunction (Params, ErrType, ErrParam)
	else if FuncName = 'NORMDIST' then
		Result := ESBNormDistFunction (Params, ErrType, ErrParam)
	else if FuncName = 'LOGNORMDIST' then
		Result := ESBLogNormDistFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBAVE' then
		Result := ESBAveFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBRMS' then
		Result := ESBRMSFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBVARSAMP' then
		Result := ESBVarSampFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBVARPOP' then
		Result := ESBVarPopFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBSTDDEVSAMP' then
		Result := ESBStdDevSampFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBSTDDEVPOP' then
		Result := ESBStdDevPopFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBMEDIAN' then
		Result := ESBMedianFunction (Params, ErrType, ErrParam)
	else if FuncName = 'ESBIQR' then
		Result := ESBIQRFunction (Params, ErrType, ErrParam)
	else if FuncName = 'KURTOSISSAMP' then
		Result := ESBKurtosisSampFunction (Params, ErrType, ErrParam)
	else if FuncName = 'KURTOSISPOP' then
		Result := ESBKurtosisPopFunction (Params, ErrType, ErrParam)
	else if FuncName = 'SKEWSAMP' then
		Result := ESBSkewSampFunction (Params, ErrType, ErrParam)
	else if FuncName = 'SKEWPOP' then
		Result := ESBSkewPopFunction (Params, ErrType, ErrParam)
end;

function TESBPCSMathLib.HandlesFunction(FuncName: string): boolean;
begin
  Result := (FuncName = 'GCD')
		or (FuncName = 'LCM')
		or (FuncName = 'RELPRIME')
		or (FuncName = 'DISTANCE')
		or (FuncName = 'EXTMOD')
		or (FuncName = 'EXTREM')
		or (FuncName = 'ESBFACT')
		or (FuncName = 'ESBPERM')
		or (FuncName = 'ESBCOMB')
		or (FuncName = 'ESBTAN')
		or (FuncName = 'ESBCOT')
		or (FuncName = 'ESBARCTAN')
		or (FuncName = 'ESBARCSIN')
		or (FuncName = 'ESBARCCOS')
		or (FuncName = 'ESBSINDEG')
		or (FuncName = 'ESBCOSDEG')
		or (FuncName = 'ESBTANDEG')
		or (FuncName = 'ESBCOTDEG')
		or (FuncName = 'ESBARCTANDEG')
		or (FuncName = 'ESBARCSINDEG')
		or (FuncName = 'ESBARCCOSDEG')
		or (FuncName = 'GAMMA')
		or (FuncName = 'INVGAMMA')
		or (FuncName = 'LNGAMMA')
		or (FuncName = 'BETA')
		or (FuncName = 'INCOMPBETA')
		or (FuncName = 'BINOMDIST')
		or (FuncName = 'POISSON')
		or (FuncName = 'NORMDIST')
		or (FuncName = 'LOGNORMDIST')
		or (FuncName = 'ESBAVE')
		or (FuncName = 'ESBRMS')
		or (FuncName = 'ESBVARSAMP')
		or (FuncName = 'ESBVARPOP')
		or (FuncName = 'ESBSTDDEVSAMP')
		or (FuncName = 'ESBSTDDEVPOP')
		or (FuncName = 'ESBMEDIAN')
		or (FuncName = 'ESBIQR')
		or (FuncName = 'KURTOSISSAMP')
		or (FuncName = 'KURTOSISPOP')
		or (FuncName = 'SKEWSAMP')
		or (FuncName = 'SKEWPOP')
end;

function TESBPCSMathLib.GetEditHint (FuncName: string; ParamIndex: Integer): string;
begin
	if FuncName = 'GCD' then
		Result := 'GCD(<b>X, Y: LongWord</b>):LongWord<HR>'
			+ 'Returns the Greatest Common Divisor of X and Y<BR>'
			+ '0 &lt;= X &lt;= High (LongWord), X will be rounded if not integral<BR>'
			+ '0 &lt;= Y &lt;= High (LongWord), Y will be rounded if not integral'
	else if FuncName = 'LCM' then
		Result := 'LCM(<b>X, Y: LongWord</b>):INT64<HR>'
			+ 'Returns the Lowest Common Multiplier of X and Y<BR>'
			+ '0 &lt;= X &lt;= High (LongWord), X will be rounded if not integral<BR>'
			+ '0 &lt;= Y &lt;= High (LongWord), Y will be rounded if not integral'
	else if FuncName = 'RELPRIME' then
		Result := 'RelPrime(<b>X, Y: LongWord</b>):Boolean<HR>'
			+ 'Returns 1 if X and Y are Relatively Prime, otherwise 0<BR>'
			+ '0 &lt;= X &lt;= High (LongWord), X will be rounded if not integral<BR>'
			+ '0 &lt;= Y &lt;= High (LongWord), Y will be rounded if not integral'
	else if FuncName = 'DISTANCE' then
		Result := 'Distance (<b>X1, Y1, X2, Y2: Double</b>): Double<HR>'
			+ 'Returns the straight line distance between  (X1, Y1) and (X2, Y2)'
	else if FuncName = 'EXTMOD' then
		Result := 'ExtMod (<b>X, Y: double</b>): Double<HR>'
			+ 'Returns Floating Point Modulus<BR>'
			+ 'ExtMod := X - Floor ( X / Y ) * Y<BR>'
			+ 'Y &lt;&gt; 0'
	else if FuncName = 'EXTREM' then
		Result := 'ExtRem (<b>X, Y: double</b>): Double<HR>'
			+ 'Returns Floating Point Remainder<BR>'
			+ 'ExtMod := X - Int ( X / Y ) * Y<BR>'
			+ 'Y &lt;&gt; 0'
	else if FuncName = 'ESBFACT' then
		Result := 'ESBFact (<b>X: LongWord</b>): Double<HR>'
			+ 'Returns Factorial X<BR>'
			+ '0 &lt;= X &lt;= 1754, X will be rounded if not integral'
	else if FuncName = 'ESBPERM' then
		Result := 'ESBPerm (<b>N, R: LongWord</b>): Double<HR>'
			+ 'Returns the number of Permutations of R Objects from N<BR>'
			+ '0 &lt;= N &lt;= 1754, N will be rounded if not integral<BR>'
			+ '0 &lt;= R &lt;= N, R will be rounded if not integral'
	else if FuncName = 'ESBCOMB' then
		Result := 'ESBComb (<b>N, R: LongWord</b>): Double<HR>'
			+ 'Returns the number of Combinations of R Objects from N<BR>'
			+ '0 &lt;= N &lt;= 1754, N will be rounded if not integral<BR>'
			+ '0 &lt;= R &lt;= N, R will be rounded if not integral'
	else if FuncName = 'ESBTAN' then
		Result := 'ESBTan (<b>X: Double</b>): Double<HR>'
			+ 'Returns the Tangent of Angle X, given in Radians<BR>'
			+ 'abs (x) &lt; 2^63'
	else if FuncName = 'ESBCOT' then
		Result := 'ESBCot (<b>X: Double</b>): Double<HR>'
			+ 'Returns the CoTangent of Angle X, given in Radians<BR>'
			+ 'abs (x) &lt; 2^63'
	else if FuncName = 'ESBARCTAN' then
		Result := 'ESBArcTan (<b>X, Y: Double</b>): Double<HR>'
			+ 'ArcTangent of Y / X - Result is in Radians'
	else if FuncName = 'ESBARCSIN' then
		Result := 'ESBArcSin (<b>X: Double</b>): Double<HR>'
			+ 'ArcSine of X - Result is in Radians'
	else if FuncName = 'ESBARCCOS' then
		Result := 'ESBArcCos (<b>X: Double</b>): Double<HR>'
			+ 'ArcCosine of X - Result is in Radians'
	else if FuncName = 'ESBTANDEG' then
		Result := 'ESBTanDeg (<b>X: Double</b>): Double<HR>'
			+ 'Returns the Tangent of Angle X, given in Degrees<BR>'
			+ 'abs (x) &lt; 2^63'
	else if FuncName = 'ESBSINDEG' then
		Result := 'ESBSinDeg (<b>X: Double</b>): Double<HR>'
			+ 'Returns the Sine of Angle X, given in Degrees<BR>'
			+ 'abs (x) &lt; 2^63'
	else if FuncName = 'ESBCOSDEG' then
		Result := 'ESBCosDeg (<b>X: Double</b>): Double<HR>'
			+ 'Returns the Cosine of Angle X, given in Degrees<BR>'
			+ 'abs (x) &lt; 2^63'
	else if FuncName = 'ESBCOTDEG' then
		Result := 'ESBCotDeg (<b>X: Double</b>): Double<HR>'
			+ 'Returns the CoTangent of Angle X, given in Degrees<BR>'
			+ 'abs (x) &lt; 2^63'
	else if FuncName = 'ESBARCTANDEG' then
		Result := 'ESBArcTanDeg (<b>X, Y: Double</b>): Double<HR>'
			+ 'ArcTangent of Y / X - Result is in Degrees'
	else if FuncName = 'ESBARCSINDEG' then
		Result := 'ESBArcSinDeg (<b>X: Double</b>): Double<HR>'
			+ 'ArcSine of X - Result is in Degrees'
	else if FuncName = 'ESBARCCOSDEG' then
		Result := 'ESBArcCosDeg (<b>X: Double</b>): Double<HR>'
			+ 'ArcCosine of X - Result is in Degrees'
	else if FuncName = 'GAMMA' then
		Result := 'Gamma (<b>X: Double</b>): Double<HR>'
			+ 'Returns Gamma (X)'
	else if FuncName = 'INVGAMMA' then
		Result := 'InvGamma (<b>X: Double</b>): Double<HR>'
			+ 'Returns 1 / Gamma (X)'
	else if FuncName = 'LNGAMMA' then
		Result := 'LnGamma (<b>X: Double</b>): Double<HR>'
			+ 'Returns the Natural Logarithm of Gamma (X)'
	else if FuncName = 'BETA' then
		Result := 'Beta (<b>X, Y: Double</b>): Double<HR>'
			+ 'Returns Beta (X, Y)'
	else if FuncName = 'INCOMPBETA' then
		Result := 'InCompBeta (<b>X, P, Q: Double</b>): Double<HR>'
			+ 'Returns Incomplete Beta Ix (P, Q)<BR>'
			+ '0 &lt;= X &lt;= 1, P &gt; 0, Q &gt; 0'
	else if FuncName = 'BINOMDIST' then
		Result := 'BinomDist (<b>A, N: Integer; P: Double; Cumulative: Boolean</b>): Double<HR>'
			+ 'Returns Binomal Distribution<BR>'
			+ 'N is the no. of Trials, P is the probability of Success<BR>'
			+ 'If Cumulative then returns Pr(X <= A) else Pr(X = A)'
	else if FuncName = 'POISSON' then
		Result := 'Poisson (<b>A: Integer; Mean: Double; Cumulative: Boolean</b>): Double<HR>'
			+ 'Returns Poisson Distribution<BR>'
			+ 'A is the no. of Events<BR>'
			+ 'If Cumulative then returns Pr(X <= A) else Pr(X = A)'
	else if FuncName = 'NORMDIST' then
		Result := 'NormDist (<b>A, Mean, StdDev: Double</b>): Double<HR>'
			+ 'Returns Normal Distribution<BR>'
			+ 'Returns Pr(X <= A)'
	else if FuncName = 'ESBAVE' then
		Result := 'ESBAve (<b>Param1,..ParamN: Double</b>): Double<HR>'
			+ 'Returns the Arithmetic Mean'
	else if FuncName = 'ESBRMS' then
		Result := 'ESBRMS (<b>Param1,..ParamN: Double</b>): Double<HR>'
			+ 'Returns the Root Mean Square'
	else if FuncName = 'ESBVARSAMP' then
		Result := 'ESBVarSamp (<b>Param1,..ParamN: Double</b>): Double<HR>'
			+ 'Returns the Variance assuming Sample Data'
	else if FuncName = 'ESBVARPOP' then
		Result := 'ESBVarPop (<b>Param1,..ParamN: Double</b>): Double<HR>'
			+ 'Returns the Variance assuming Population Data'
	else if FuncName = 'ESBSTDDEVSAMP' then
		Result := 'ESBStdDevSamp (<b>Param1,..ParamN: Double</b>): Double<HR>'
			+ 'Returns the Standard Deviation assuming Sample Data'
	else if FuncName = 'ESBSTDDEVPOP' then
		Result := 'ESBStdDevPop (<b>Param1,..ParamN: Double</b>): Double<HR>'
			+ 'Returns the Standard Deviation assuming Sample Data'
	else if FuncName = 'ESBMEDIAN' then
		Result := 'ESBMedian (<b>Param1,..ParamN: Double</b>): Double<HR>'
			+ 'Returns the Median'
	else if FuncName = 'ESBIQR' then
		Result := 'ESBIQR (<b>Param1,..ParamN: Double</b>): Double<HR>'
			+ 'Returns the Inter-Quartile Range'
	else if FuncName = 'KURTOSISSAMP' then
		Result := 'KurtosisSamp (<b>Param1,..ParamN: Double</b>): Double<HR>'
			+ 'Returns the Kurtosis assuming Sample Data<BR>'
			+ 'Requires at least 4 values'
	else if FuncName = 'KURTOSISPOP' then
		Result := 'KurtosisPop (<b>Param1,..ParamN: Double</b>): Double<HR>'
			+ 'Returns the Kurtosis assuming Population Data<BR>'
			+ 'Requires at least 4 values'
	else if FuncName = 'SKEWSAMP' then
		Result := 'SkewSamp (<b>Param1,..ParamN: Double</b>): Double<HR>'
			+ 'Returns the Skew assuming Sample Data<BR>'
			+ 'Requires at least 3 values'
	else if FuncName = 'SKEWPOP' then
		Result := 'SkewPop (<b>Param1,..ParamN: Double</b>): Double<HR>'
			+ 'Returns the Skew assuming Population Data<BR>'
			+ 'Requires at least 3 values'
end;


end.
